<template>
  <v-menu
    v-model="menu"
    :close-on-content-click="false"
    :nudge-right="40"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template #activator="{ on }">
      <GTextField
        v-model="date"
        :validate="validate"
        :label="label"
        :i18n="i18n"
        prepend-icon="event"
        readonly
        v-on="on"
      />
    </template>
    <v-date-picker
      v-model="date"
      v-bind="$attrs"
      no-title
      scrollable
      :locale="$i18n.locale"
      :first-day-of-week="firstDayOfWeek"
      :min="minString"
      :max="maxString"
      @input="menu = false"
    >
      <v-btn text color="error" @click="clearDate">
        {{ $t("form.clear") }}
      </v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
import { format, isDate } from "date-fns";
import GTextField from "./gTextField";

const dateFormat = "yyyy-MM-dd";

export default {
  name: "GDatePicker",
  components: { GTextField },
  inheritAttrs: true,
  props: {
    value: Date,
    min: Date,
    max: Date,
    label: String,
    i18n: String,
    validate: String,
  },
  data() {
    return {
      menu: false,
    };
  },
  computed: {
    date: {
      get() {
        return isDate(this.value) ? format(this.value, dateFormat) : "";
      },
      set(value) {
        this.$emit("input", value ? new Date(value) : null);
      },
    },
    minString() {
      return this.min ? format(this.min, dateFormat) : null;
    },
    maxString() {
      return this.max ? format(this.max, dateFormat) : null;
    },
    firstDayOfWeek() {
      return parseInt(this.$t("lang.firstDayOfWeek"));
    },
  },
  methods: {
    clearDate() {
      this.date = null;
      this.menu = false;
    },
  },
};
</script>
